static void rotate_ud_eperms(p)
int *p;
{
int p1[8], p2[8], i;

    p1[0] = 1;
    p1[1] = 2;
    p1[2] = 3;
    p1[3] = 0;
    p1[4] = 5;
    p1[5] = 6;
    p1[6] = 7;
    p1[7] = 4;
    for(i = 0; i < 8; i++) {
	p2[i] = p1[p[i]];
    }
    p[0] = p2[3];
    p[1] = p2[0];
    p[2] = p2[1];
    p[3] = p2[2];
    p[4] = p2[7];
    p[5] = p2[4];
    p[6] = p2[5];
    p[7] = p2[6];
}

static void rotate_rl_eperms(p)
int *p;
{
int p1[8], p2[8], i;

    p1[0] = 6;
    p1[1] = 5;
    p1[2] = 4;
    p1[3] = 7;
    p1[4] = 2;
    p1[5] = 1;
    p1[6] = 0;
    p1[7] = 3;
    for(i = 0; i < 8; i++) {
	p2[i] = p1[p[i]];
    }
    p[0] = p2[6];
    p[1] = p2[5];
    p[2] = p2[4];
    p[3] = p2[7];
    p[4] = p2[2];
    p[5] = p2[1];
    p[6] = p2[0];
    p[7] = p2[3];
}

static void flip_eperms(p)
int *p;
{
int p1[8], p2[8], i;

    p1[0] = 4;
    p1[1] = 5;
    p1[2] = 6;
    p1[3] = 7;
    p1[4] = 0;
    p1[5] = 1;
    p1[6] = 2;
    p1[7] = 3;
    for(i = 0; i < 8; i++) {
	p2[i] = p1[p[i]];
    }
    p[0] = p2[4];
    p[1] = p2[5];
    p[2] = p2[6];
    p[3] = p2[7];
    p[4] = p2[0];
    p[5] = p2[1];
    p[6] = p2[2];
    p[7] = p2[3];
}

